/*
 * _gen/svc-Connection_Interface_Renaming.c - Source for IdleSvcConnectionInterfaceRenaming
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include "_gen/svc-Connection_Interface_Renaming.h"

#include <stdio.h>
#include <stdlib.h>

#include <telepathy-glib/dbus.h>
#include "signals-marshal.h"

const DBusGObjectInfo dbus_glib_idle_svc_connection_interface_renaming_object_info;
struct _IdleSvcConnectionInterfaceRenamingClass {
    GTypeInterface parent_class;
    idle_svc_connection_interface_renaming_request_rename_impl request_rename;
};

enum {
    SIGNAL_Renamed,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
idle_svc_connection_interface_renaming_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_Renamed] =
      g_signal_new ("renamed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _idle_ext_marshal_VOID__UINT_UINT,
                    G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);

      dbus_g_object_type_install_info (idle_svc_connection_interface_renaming_get_type (), &dbus_glib_idle_svc_connection_interface_renaming_object_info);
    }
}

GType
idle_svc_connection_interface_renaming_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (IdleSvcConnectionInterfaceRenamingClass),
      idle_svc_connection_interface_renaming_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "IdleSvcConnectionInterfaceRenaming", &info, 0);
  }

  return type;
}


/**
 * idle_svc_connection_interface_renaming_request_rename_impl
 * @self: The object implementing this interface
 * @name: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method RequestRename
 * on interface org.freedesktop.Telepathy.Connection.Interface.Renaming
 */
static void
idle_svc_connection_interface_renaming_request_rename (IdleSvcConnectionInterfaceRenaming *self,
                                                       const gchar *name,
                                                       DBusGMethodInvocation *context)
{
  idle_svc_connection_interface_renaming_request_rename_impl impl = (IDLE_SVC_CONNECTION_INTERFACE_RENAMING_GET_CLASS (self)->request_rename);
  if (impl)
    (impl) (self, name, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * idle_svc_connection_interface_renaming_implement_request_rename:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the RequestRename method
 *
 * Register an implementation for the RequestRename method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
idle_svc_connection_interface_renaming_implement_request_rename (IdleSvcConnectionInterfaceRenamingClass *klass, idle_svc_connection_interface_renaming_request_rename_impl impl)
{
  klass->request_rename = impl;
}

/**
 * idle_svc_connection_interface_renaming_emit_renamed:
 * @instance: An object implementing this interface
 * @original: FIXME: document args in genginterface
 * @new: FIXME: document args in genginterface
 *
 * Emit the Renamed D-Bus signal from @instance with the given arguments.
 */
void idle_svc_connection_interface_renaming_emit_renamed (gpointer instance,
    const guint  original,
    const guint  new)
{
  g_assert (IDLE_IS_SVC_CONNECTION_INTERFACE_RENAMING (instance));
  g_signal_emit (instance, signals[SIGNAL_Renamed], 0, original, new);
}

#include "_gen/svc-Connection_Interface_Renaming-glue.h"

